﻿Type.registerNamespace('Dflying');

Dflying.ValidateUserNameBehavior = function() {
    Dflying.ValidateUserNameBehavior.initializeBase(this);
    
    var _blurHandler;
    
    var _checkResultLabelID;
    var _checkResultLabel;
    var _serviceName;
    var _methodName;
    var _validMessage = "You can use this user name.";
    var _invalidMessage = "This user name has already been used, please choose another.";
    
    this.get_checkResultLabelID = function() {
        return _checkResultLabelID;
    }
    this.set_checkResultLabelID = function(value) {
        if (_checkResultLabelID != value) {
            _checkResultLabel = $(value);
debug.assert(_checkResultLabel != null, "checkResultLabelID must be set to a valid DOM element.");
            _checkResultLabelID = value;
            this.raisePropertyChanged('checkResultLabelID');
        }
    }
    this.get_serviceName = function() {
        return _serviceName;
    }
    this.set_serviceName = function(value) {
        if (_serviceName != value) {
            _serviceName = value;
            this.raisePropertyChanged('serviceName');
        }
    }
    this.get_methodName = function() {
        return _methodName;
    }
    this.set_methodName = function(value) {
        if (_methodName != value) {
            _methodName = value;
            this.raisePropertyChanged('methodName');
        }
    }
    this.get_validMessage = function() {
        return _validMessage;
    }
    this.set_validMessage = function(value) {
        if (_validMessage != value) {
            _validMessage = value;
            this.raisePropertyChanged('validMessage');
        }
    }
    this.get_invalidMessage = function() {
        return _invalidMessage;
    }
    this.set_invalidMessage = function(value) {
        if (_invalidMessage != value) {
            _invalidMessage = value;
            this.raisePropertyChanged('invalidMessage');
        }
    }
    
    this.initialize = function() {
        Dflying.ValidateUserNameBehavior.callBaseMethod(this, 'initialize');

        _blurHandler = Function.createDelegate(this, blurHandler);
        this.control.element.attachEvent('onblur', _blurHandler);
    }
    
    this.dispose = function() {
        if (_blurHandler) {
            this.control.element.detachEvent('onblur', _blurHandler);
            _blurHandler = null;
        }
        
        Dflying.ValidateUserNameBehavior.callBaseMethod(this, 'dispose');
    }

    this.getDescriptor = function() {
        var td = Sys.UI.HoverBehavior.callBaseMethod(this, 'getDescriptor');
        td.addProperty('checkResultLabelID', String);
        td.addProperty('serviceName', String);
        td.addProperty('methodName', String);
        td.addProperty('validMessage', String);
        td.addProperty('invalidMessage', String);
        return td;
    }
    
    function blurHandler() {
        if (this.control.element.value == '') {
            _checkResultLabel.innerHTML = '';
            return;
        }
        
        Sys.Net.ServiceMethod.invoke(
            _serviceName, 
            _methodName, 
            '',
            { userNameCandidate : this.control.element.value},
            _onMethodComplete
        );
    }
    
    function _onMethodComplete(result)
    {
        _checkResultLabel.innerHTML = result ? _validMessage : _invalidMessage;
    }
}
Dflying.ValidateUserNameBehavior.registerSealedClass('Dflying.ValidateUserNameBehavior', Sys.UI.Behavior);
Sys.TypeDescriptor.addType('script', 'validateUserNameBehavior', Dflying.ValidateUserNameBehavior);